Index: trunk/src/emx/src/lib/libc.specs
===================================================================
--- trunk/src/emx/src/lib/libc.specs	(revision 411)
+++ 	(revision )
@@ -1,141 +1,0 @@
-*asm:
---traditional-format %{Zomf} %{s:-Zstrip}
-
-*asm_debug:
-%{g*:--gstabs}
-
-*asm_final:
-
-
-*asm_options:
-%a %Y %{c:%W{o*}%{!o*:-o %w%b%O}}%{!c:-o %d%w%u%O}
-
-*invoke_as:
-%{!S:-o %{|!pipe:%g.s} |
- as %(asm_options) %{!pipe:%g.s} %A }
-
-*cpp:
-%(cpp_cpu) %{posix:-D_POSIX_SOURCE} %{Zmt*:}  %{pg:-D__GPROF__} %{mepilogue:-D__EPILOGUE__} %{mprobe|mstack-arg-probe:-D__STACK_PROBE__} -D__cdecl=__attribute__((__cdecl__)) -D__stdcall=__attribute__((__stdcall__)) %{!ansi: -D_cdecl=__attribute__((__cdecl__)) -D_stdcall=__attribute__((__stdcall__)) -D_Cdecl=__attribute__((__cdecl__)) -D_Optlink=__attribute__((__optlink__)) -D_System=__attribute__((__system__))}
-
-*cpp_options:
-%(cpp_unique_options) %{std*} %{d*} %{W*} %{w} %{pedantic*} %{fshow-column} %{fno-show-column} %{fsigned-char&funsigned-char} %{fleading-underscore} %{fno-leading-underscore} %{fno-operator-names} %{ftabstop=*}
-
-*cpp_unique_options:
-%{C:%{!E:%eGNU C does not support -C without using -E}} %{nostdinc*} %{C} %{v} %{I*} %{P} %{$} %I %{MD:-MD %{!o:%b.d}%{o*:%.d%*}} %{MMD:-MMD %{!o:%b.d}%{o*:%.d%*}} %{M} %{MM} %{MF*} %{MG} %{MP} %{MQ*} %{MT*} %{!E:%{!M:%{!MM:%{MD|MMD:%{o*:-MQ %*}}}}} %{!no-gcc:-D__GNUC__=%v1 -D__GNUC_MINOR__=%v2 -D__GNUC_PATCHLEVEL__=%v3 -D__GXX_ABI_VERSION=102} %{!undef:%{!ansi:%{!std=*:%p}%{std=gnu*:%p}} %P} %{trigraphs} %{Os:-D__OPTIMIZE_SIZE__} %{O*:%{!O0:-D__OPTIMIZE__}} %{fno-inline|O0|!O*:-D__NO_INLINE__} %{ffast-math:-D__FAST_MATH__} %{ffreestanding:-D__STDC_HOSTED__=0} %{fno-hosted:-D__STDC_HOSTED__=0} %{!ffreestanding:%{!fno-hosted:-D__STDC_HOSTED__=1}} %{remap} %{g3:-dD} %{H} %C %{fshort-wchar:-U__WCHAR_TYPE__ -D__WCHAR_TYPE__=short\ unsigned\ int} %{D*&U*&A*} %{i*} %Z %i %{E|M|MM:%W{o*}}
-
-*trad_capable_cpp:
-%{traditional|ftraditional|traditional-cpp:trad}cpp0
-
-*cc1:
-%(cc1_cpu)
-
-*cc1_options:
-%{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}} %1 %{!Q:-quiet} -dumpbase %B %{d*} %{m*} %{a*} %{g*} %{O*} %{W*} %{w} %{pedantic*} %{std*} %{ansi} %{traditional} %{v:-version} %{pg:-p} %{p} %{f*} %{Qn:-fno-ident} %{--help:--help} %{--target-help:--target-help} %{!fsyntax-only:%{S:%W{o*}%{!o*:-o %b.s}}} %{fsyntax-only:-o %j} %{-param*}
-
-*cc1plus:
-
-
-*link_gcc_c_sequence:
-%G %L %G
-
-*endfile:
-
-
-*link:
-%{Zexe} %{Zstack*} %{Zmap*} %{Zomf:%{Zdll}} %{!o*:-o %b%{Zdll:.dll}%{!Zdll:%{!Zexe:.exe}}} %{static:%{Zcrtdll*:%e-static and -Zcrtdll are incompatible}}%{Zdll:%{Zexe:%e-Zdll and -Zexe are incompatible}}%{Zsmall-conv:%{Zcrtdll*:%e-Zsmall-conv and -Zcrtdll are incompatible}}
-
-*lib:
--lc%{p|pg:_p} %G %{!Zdll:-lc_app%{pg:_p}} -lc%{p|pg:_p}
-
-*libgcc:
-%{static|static-libgcc:%{shared-libgcc:%e-static-libgcc and -shared-libgcc are incompatible}}%{shared-libgcc:-lgcc%v1%v2%v3}%{!shared-libgcc:%{!static-libgcc:%{Zcrtdll*:-lgcc%v1%v2%v3}}}%{!shared-libgcc:%{static-libgcc|!Zcrtdll*:-lgcc_eh -lgcc}}
-
-*startfile:
-%{Zdll:dll0%O%{Zomf:bj}%s}%{!Zdll:%{pg:gcrt0%O%{Zomf:bj}%s}%{!pg:%{pn:gcrt0%O%{Zomf:bj}%s}%{!pn:%{p:mcrt0%O%{Zomf:bj}%s}%{!p:crt0%O%{Zomf:bj}%s}}} %{Zbin-files:binmode%O%{Zomf:bj}%s} %{Zsmall-conv:smallcnv%O%{Zomf:bj}%s}}
-
-*switches_need_spaces:
-
-
-*predefines:
--D__32BIT__ -D__EMX__ -D__OS2__ -D__i386__ -D__i386 -Dunix -D__MT__ -Asystem=unix -Asystem=posix
-
-# this is weird, -D__MT__ doesn't really work with C++ unless put here.
-
-*cross_compile:
-0
-
-*version:
-3.2.2
-
-*multilib:
-. ;
-
-*multilib_defaults:
-
-
-*multilib_extra:
-
-
-*multilib_matches:
-
-
-*multilib_exclusions:
-
-
-*multilib_options:
-
-
-*linker:
-collect2
-
-*link_libgcc:
-%D
-
-*md_exec_prefix:
-
-
-*md_startfile_prefix:
-
-
-*md_startfile_prefix_1:
-
-
-*cpp_cpu_default:
--D__tune_i386__
-
-*cpp_cpu:
-%(cpp_cpu32) %(cpp_cpucommon)
-
-*cpp_cpu32:
--Acpu=i386 -Amachine=i386 %{!ansi:%{!std=c*:%{!std=i*:-Di386}}} -D__i386 -D__i386__ %(cpp_cpu32sizet)
-
-*cpp_cpu64:
--Acpu=x86_64 -Amachine=x86_64 -D__x86_64 -D__x86_64__ %(cpp_cpu64sizet)
-
-*cpp_cpu32sizet:
-
-
-*cpp_cpu64sizet:
-
-
-*cpp_cpucommon:
-%{march=i386:%{!mcpu*:-D__tune_i386__ }}%{march=i486:-D__i486 -D__i486__ %{!mcpu*:-D__tune_i486__ }}%{march=pentium|march=i586:-D__i586 -D__i586__ -D__pentium -D__pentium__   %{!mcpu*:-D__tune_i586__ -D__tune_pentium__ }}%{march=pentium-mmx:-D__i586 -D__i586__ -D__pentium -D__pentium__   -D__pentium__mmx__   %{!mcpu*:-D__tune_i586__ -D__tune_pentium__ -D__tune_pentium_mmx__}}%{march=pentiumpro|march=i686|march=pentium2|march=pentium3:-D__i686 -D__i686__   -D__pentiumpro -D__pentiumpro__   %{!mcpu*:-D__tune_i686__ -D__tune_pentiumpro__ }}%{march=march=pentium2|march=pentium3: -D__pentium2 -D__pentium2__  %{!mcpu*:-D__tune_pentium2__ }}%{march=pentium3: -D__pentium3 -D__pentium3__  %{!mcpu*:-D__tune_pentium3__ }}%{march=k6:-D__k6 -D__k6__ %{!mcpu*:-D__tune_k6__ }}%{march=k6-2:-D__k6 -D__k6__ -D__k6_2__   %{!mcpu*:-D__tune_k6__ -D__tune_k6_2__ }}%{march=k6-3:-D__k6 -D__k6__ -D__k6_3__   %{!mcpu*:-D__tune_k6__ -D__tune_k6_3__ }}%{march=athlon|march=athlon-tbird:-D__athlon -D__athlon__   %{!mcpu*:-D__tune_athlon__ }}%{march=athlon-4|march=athlon-xp|march=athlon-mp:-D__athlon -D__athlon__   -D__athlon_sse__   %{!mcpu*:-D__tune_athlon__ -D__tune_athlon_sse__ }}%{march=pentium4:-D__pentium4 -D__pentium4__ %{!mcpu*:-D__tune_pentium4__ }}%{m386|mcpu=i386:-D__tune_i386__ }%{m486|mcpu=i486:-D__tune_i486__ }%{mpentium|mcpu=pentium|mcpu=i586|mcpu=pentium-mmx:-D__tune_i586__ -D__tune_pentium__ }%{mpentiumpro|mcpu=pentiumpro|mcpu=i686|mcpu=pentium2|mcpu=pentium3:-D__tune_i686__ -D__tune_pentiumpro__ }%{mcpu=k6|mcpu=k6-2|mcpu=k6-3:-D__tune_k6__ }%{mcpu=athlon|mcpu=athlon-tbird|mcpu=athlon-4|mcpu=athlon-xp|mcpu=athlon-mp:-D__tune_athlon__ }%{mcpu=athlon-4|mcpu=athlon-xp|mcpu=athlon-mp:-D__tune_athlon_sse__ }%{mcpu=pentium4:-D__tune_pentium4__ }%{march=athlon-xp|march=athlon-mp|march=pentium3|march=pentium4|msse|msse2:-D__SSE__ }%{march=pentium-mmx|march=k6|march=k6-2|march=k6-3|march=athlon|march=athlon-tbird|march=athlon-4|march=athlon-xp|march=athlon-mp|march=pentium2|march=pentium3|march=pentium4|mmx|msse|m3dnow: -D__MMX__ }%{march=k6-2|march=k6-3|march=athlon|march=athlon-tbird|march=athlon-4|march=athlon-xp|march=athlon-mp|m3dnow: -D__3dNOW__ }%{march=athlon|march=athlon-tbird|march=athlon-4|march=athlon-xp|march=athlon-mp: -D__3dNOW_A__ }%{march=pentium4|msse2: -D__SSE2__ }%{!march*:%{!mcpu*:%{!m386:%{!m486:%{!mpentium*:%(cpp_cpu_default)}}}}}
-
-*cc1_cpu:
-%{!mcpu*: %{m386:-mcpu=i386 %n`-m386' is deprecated. Use `-march=i386' or `-mcpu=i386' instead.
-} %{m486:-mcpu=i486 %n`-m486' is deprecated. Use `-march=i486' or `-mcpu=i486' instead.
-} %{mpentium:-mcpu=pentium %n`-mpentium' is deprecated. Use `-march=pentium' or `-mcpu=pentium' instead.
-} %{mpentiumpro:-mcpu=pentiumpro %n`-mpentiumpro' is deprecated. Use `-march=pentiumpro' or `-mcpu=pentiumpro' instead.
-}} %{mintel-syntax:-masm=intel %n`-mintel-syntax' is deprecated. Use `-masm=intel' instead.
-} %{mno-intel-syntax:-masm=att %n`-mno-intel-syntax' is deprecated. Use `-masm=att' instead.
-}
-
-*link_command:
-%{!fsyntax-only:  %{!c:%{!M:%{!MM:%{!E:%{!S:%{Zomf:emxomf}ld %l %X %{o*} %{A} %{d} %{e*} %{m} %{N} %{n} %{r} %{s} %{t} %{u*} %{x} %{z} %{Z} %{!A:%{!nostdlib:%{!nostartfiles:%S}}} %{static:} %{L*} %D %{T*} %o %{!nostdlib:%{!nodefaultlibs:%G -lc_alias %{!Zcrtdll*:%L} %{Zcrtdll*:-lc_dll} -los2%{pg:_p}  %{!Zcrtdll*:%L} %{Zcrtdll*:-lc_dll} -los2%{pg:_p} %{Zomf:-lend}}} %{!A:%{!nostdlib:%{!nostartfiles:%E}}}}}}}}}
-
-# stage 2?
-#%{!fsyntax-only: %{!c:%{!M:%{!MM:%{!E:%{!S:%{Zomf:emxomf}ld %l %X %{o*} %{A} %{d} %{e*} %{m} %{N} %{n} %{r} %{s} %{t} %{u*} %{x} %{z} %{Z} %{!A:%{!nostdlib:%{!nostartfiles:%S}}} %{static:} %{L*} %D %{T*} %o %{!nostdlib:%{!nodefaultlibs:%G -lc_alias %{!Zcrtdll*:%L} %{Zcrtdll=*:-l%* -los2%{pg:_p}} -los2%{pg:_p} %{Zomf:-lend}}} %{!A:%{!nostdlib:%{!nostartfiles:%E}}}}}}}}}
-
-# bird: while -Zcrtdll isn't working.
-#%{!fsyntax-only: %{!c:%{!M:%{!MM:%{!E:%{!S:%{Zomf:emxomf}ld %l %X %{o*} %{A} %{d} %{e*} %{m} %{N} %{n} %{r} %{s} %{t} %{u*} %{x} %{z} %{Z} %{!A:%{!nostdlib:%{!nostartfiles:%S}}} %{static:} %{L*} %D %{T*} %o %{!nostdlib:%{!nodefaultlibs:%G -lc_alias %{!Zcrtdll*:%L} -los2%{pg:_p} %{Zomf:-lend}}} %{!A:%{!nostdlib:%{!nostartfiles:%E}}}}}}}}}
-# bird: Urg! Because of the thunks we have to repeate the -lc -los2 (%L -los2{}) sequence. I'm getting unresolved thunkers elsewise when linking xgcc.exe with clh.