Index: trunk/src/gcc/gcc/config/i386/t-emx
===================================================================
--- trunk/src/gcc/gcc/config/i386/t-emx	(revision 424)
+++ trunk/src/gcc/gcc/config/i386/t-emx	(revision 425)
@@ -7,11 +7,11 @@
 #SHLIB_DLLNAME  = $(SHLIB_MULTINAME).dll
 #SHLIB_LINK     = export DLLAR_CMDLINE="@shlib_objs@" && \
-#       kRx.exe dllar.cmd -o $$(@D)/$(SHLIB_DLLNAME) \
-#       -ordinal @multilib_flags@ -nocrtdll \
-#       -ex "__main __do_global_* _GLOBAL* _exit_dummy_ref __ctordtor* __eh* _DLL_InitTerm" \
-#       -d "GNU C runtime shared library version $(gcc_version)" \
-#       -libf "INITINSTANCE TERMGLOBAL" -lc_static -lc_import \
+#	kRx.exe dllar.cmd -o $$(@D)/$(SHLIB_DLLNAME) \
+#	-ordinal @multilib_flags@ -nocrtdll \
+#	-ex "__main __do_global_* _GLOBAL* _exit_dummy_ref __ctordtor* __eh* _DLL_InitTerm" \
+#	-d "GNU C runtime shared library version $(gcc_version)" \
+#	-libf "INITINSTANCE TERMGLOBAL" -lc_static -lc_import \
 #    && mv -f $$(@D)/$(SHLIB_MULTINAME).a $$(@D)/$(SHLIB_BASENAME).a \
-#       && ar rs $$(@D)/$(SHLIB_BASENAME).a libgcc/$$(@D)/__main.o libgcc/$$(@D)/emx-ctordtor.o libgcc/$$(@D)/emx-eh.o libgcc/$$(@D)/emx-dllinit.o \
+#	&& ar rs $$(@D)/$(SHLIB_BASENAME).a libgcc/$$(@D)/__main.o libgcc/$$(@D)/emx-ctordtor.o libgcc/$$(@D)/emx-eh.o libgcc/$$(@D)/emx-dllinit.o \
 #    && touch $$@
 #SHLIB_SUBDIR  = `echo @shlib_base_name@ | sed -e "s/^libgcc_s_//" -e "s,_,/,g"`
@@ -32,10 +32,10 @@
 SHLIB_DLLNAME  = $(SHLIB_MULTINAME).dll
 SHLIB_LINK     = export DLLAR_CMDLINE="@shlib_objs@" && \
-        kRx.exe dllar.cmd -o $$(@D)/$(SHLIB_DLLNAME) \
-        -ordinal @multilib_flags@ -nocrtdll \
-        -ex "___main ___do_global_* __GLOBAL* __exit_dummy_ref ___ctordtor* ___eh* _DLL_InitTerm" \
-        -d "GNU C runtime shared library version $(gcc_version)" \
-        -libf "INITINSTANCE TERMGLOBAL" -lc_alias -lc_dll \
-        && ar rs $$(@D)/$(SHLIB_BASENAME).a libgcc/$$(@D)/__main.o libgcc/$$(@D)/emx-ctordtor.o libgcc/$$(@D)/emx-eh.o libgcc/$$(@D)/emx-dllinit.o \
+	kRx.exe dllar.cmd -o $$(@D)/$(SHLIB_DLLNAME) \
+	-ordinal @multilib_flags@ -nocrtdll \
+	-ex "___main ___do_global_* __GLOBAL* __exit_dummy_ref ___ctordtor* ___eh* _DLL_InitTerm" \
+	-d "GNU C runtime shared library version $(gcc_version)" \
+	-libf "INITINSTANCE TERMGLOBAL" -lc_alias -lc_dll \
+	&& ar rs $$(@D)/$(SHLIB_BASENAME).a libgcc/$$(@D)/__main.o libgcc/$$(@D)/emx-ctordtor.o libgcc/$$(@D)/emx-eh.o libgcc/$$(@D)/emx-dllinit.o \
     && touch $$@
 SHLIB_SUBDIR  = .
@@ -103,8 +103,8 @@
 # bird (#424): dropping multilibs. Old hacks - START
 #stage1 stage2 stage3 stage4:
-#       echo "t-emx hacks: $@ starting"
-#       -mv -f *.exe *.ready st mt s-libgcc $@
-#       -rm -f $@/$(LIBGCC)
-#       echo "t-emx hacks: $@ done"
+#	echo "t-emx hacks: $@ starting"
+#	-mv -f *.exe *.ready st mt s-libgcc $@
+#	-rm -f $@/$(LIBGCC)
+#	echo "t-emx hacks: $@ done"
 
 ## Some final polishing of libgcc ...
@@ -115,20 +115,20 @@
 #$(ALL): s-libgcc
 #s-libgcc: $(LIBGCC)
-#       echo "t-emx hacks: $@ starting"
-#       cp -f st/libgcc.a st/gcc.a
-#       cp -f st/libgcc_eh.a st/gcc_eh.a
-#       cp -f mt/libgcc.a mt/gcc.a
-#       cp -f mt/libgcc_eh.a mt/gcc_eh.a
-#       $(STAMP) s-libgcc
-#       echo "t-emx hacks: $@ done"
+#	echo "t-emx hacks: $@ starting"
+#	cp -f st/libgcc.a st/gcc.a
+#	cp -f st/libgcc_eh.a st/gcc_eh.a
+#	cp -f mt/libgcc.a mt/gcc.a
+#	cp -f mt/libgcc_eh.a mt/gcc_eh.a
+#	$(STAMP) s-libgcc
+#	echo "t-emx hacks: $@ done"
 # bird (#424): dropping multilibs. Old hacks - END
 
 # bird (#424): New gcc*dll hacks
 stage1 stage2 stage3 stage4:
-        echo "t-emx hacks: $@ starting"
-        -mv -f gcc3*.dll gcc3*.a gcc3*.def $@
-        echo "t-emx hacks: $@ done"
+	echo "t-emx hacks: $@ starting"
+	-mv -f gcc3*.dll gcc3*.a gcc3*.def $@
+	echo "t-emx hacks: $@ done"
 
 emx.o: $(srcdir)/config/i386/emx.c $(RTL_H) $(TREE_H) $(CONFIG_H)
-        $(CC) -c $(ALL_CFLAGS) $(ALL_CPPFLAGS) $(INCLUDES) $(srcdir)/config/i386/emx.c
+	$(CC) -c $(ALL_CFLAGS) $(ALL_CPPFLAGS) $(INCLUDES) $(srcdir)/config/i386/emx.c
 