Index: trunk/src/user32/dde.cpp
===================================================================
--- trunk/src/user32/dde.cpp	(revision 426)
+++ trunk/src/user32/dde.cpp	(revision 427)
@@ -1,3 +1,3 @@
-/* $Id: dde.cpp,v 1.3 1999-06-10 16:50:38 phaller Exp $ */
+/* $Id: dde.cpp,v 1.4 1999-08-05 19:51:51 phaller Exp $ */
 
 /*
@@ -16,5 +16,5 @@
 BOOL WIN32API DdeAbandonTransaction( DWORD arg1, HCONV arg2, DWORD  arg3)
 {
-    dprintf(("USER32:  OS2DdeAbandonTransaction\n"));
+    dprintf(("USER32: DdeAbandonTransaction\n"));
     return O32_DdeAbandonTransaction(arg1, arg2, arg3);
 }
@@ -23,5 +23,5 @@
 PBYTE WIN32API DdeAccessData(HDDEDATA arg1, PDWORD  arg2)
 {
-    dprintf(("USER32:  OS2DdeAccessData\n"));
+    dprintf(("USER32: DdeAccessData\n"));
     return O32_DdeAccessData(arg1, arg2);
 }
@@ -30,15 +30,15 @@
 HDDEDATA WIN32API DdeAddData( HDDEDATA arg1, PVOID arg2, DWORD arg3, DWORD  arg4)
 {
-    dprintf(("USER32:  OS2DdeAddData"));
+    dprintf(("USER32: DdeAddData"));
     return O32_DdeAddData(arg1, arg2, arg3, arg4);
 }
 //******************************************************************************
 //******************************************************************************
-HDDEDATA WIN32API DdeClientTransaction(PVOID arg1, DWORD arg2, HCONV arg3, 
-                                       HSZ arg4, UINT arg5, UINT arg6, DWORD arg7, 
+HDDEDATA WIN32API DdeClientTransaction(PVOID arg1, DWORD arg2, HCONV arg3,
+                                       HSZ arg4, UINT arg5, UINT arg6, DWORD arg7,
                                        PDWORD  arg8)
 {
 
-    dprintf(("USER32:  OS2DdeClientTransaction\n"));
+    dprintf(("USER32: DdeClientTransaction\n"));
 
     return O32_DdeClientTransaction(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8);
@@ -49,5 +49,5 @@
 {
 
-    dprintf(("USER32:  OS2DdeCmpStringHandles\n"));
+    dprintf(("USER32: DdeCmpStringHandles\n"));
 
     return O32_DdeCmpStringHandles(arg1, arg2);
@@ -58,5 +58,5 @@
 {
 
-    dprintf(("USER32:  OS2DdeConnect\n"));
+    dprintf(("USER32: DdeConnect\n"));
 
     return O32_DdeConnect(arg1, arg2, arg3, arg4);
@@ -67,5 +67,5 @@
 {
 
-    dprintf(("USER32:  OS2DdeConnectList\n"));
+    dprintf(("USER32: DdeConnectList\n"));
 
     return O32_DdeConnectList(arg1, arg2, arg3, arg4, arg5);
@@ -73,8 +73,8 @@
 //******************************************************************************
 //******************************************************************************
-HDDEDATA WIN32API DdeCreateDataHandle(DWORD arg1, PVOID arg2, DWORD arg3, DWORD arg4, 
+HDDEDATA WIN32API DdeCreateDataHandle(DWORD arg1, PVOID arg2, DWORD arg3, DWORD arg4,
                                       HSZ arg5, UINT arg6, UINT  arg7)
 {
-    dprintf(("USER32:  OS2DdeCreateDataHandle\n"));
+    dprintf(("USER32: DdeCreateDataHandle\n"));
     return O32_DdeCreateDataHandle(arg1, arg2, arg3, arg4, arg5, arg6, arg7);
 }
@@ -84,5 +84,5 @@
 {
 
-    dprintf(("USER32:  OS2DdeCreateStringHandleA\n"));
+    dprintf(("USER32: DdeCreateStringHandleA\n"));
 
     return O32_DdeCreateStringHandle(arg1, arg2, arg3);
@@ -95,5 +95,5 @@
  HSZ   rc;
 
-    dprintf(("USER32:  OS2DdeCreateStringHandleW DOESN'T WORK\n"));
+    dprintf(("USER32: DdeCreateStringHandleW DOESN'T WORK\n"));
     rc = O32_DdeCreateStringHandle(arg1, astring, arg3);
     FreeAsciiString(astring);
@@ -105,5 +105,5 @@
 {
 
-    dprintf(("USER32:  OS2DdeDisconnect\n"));
+    dprintf(("USER32: DdeDisconnect\n"));
 
     return O32_DdeDisconnect(arg1);
@@ -114,5 +114,5 @@
 {
 
-    dprintf(("USER32:  OS2DdeDisconnectList\n"));
+    dprintf(("USER32: DdeDisconnectList\n"));
 
     return O32_DdeDisconnectList(arg1);
@@ -123,5 +123,5 @@
 {
 
-    dprintf(("USER32:  OS2DdeEnableCallback\n"));
+    dprintf(("USER32: DdeEnableCallback\n"));
 
     return O32_DdeEnableCallback(arg1, arg2, arg3);
@@ -132,5 +132,5 @@
 {
 
-    dprintf(("USER32:  OS2DdeFreeDataHandle\n"));
+    dprintf(("USER32: DdeFreeDataHandle\n"));
 
     return O32_DdeFreeDataHandle(arg1);
@@ -141,5 +141,5 @@
 {
 
-    dprintf(("USER32:  OS2DdeFreeStringHandle\n"));
+    dprintf(("USER32: DdeFreeStringHandle\n"));
 
     return O32_DdeFreeStringHandle(arg1, arg2);
@@ -150,5 +150,5 @@
 {
 
-    dprintf(("USER32:  OS2DdeGetData\n"));
+    dprintf(("USER32: DdeGetData\n"));
 
     return O32_DdeGetData(arg1, arg2, arg3, arg4);
@@ -159,5 +159,5 @@
 {
 
-    dprintf(("USER32:  OS2DdeGetLastError\n"));
+    dprintf(("USER32: DdeGetLastError\n"));
 
     return O32_DdeGetLastError(arg1);
@@ -168,5 +168,5 @@
 {
 
-    dprintf(("USER32:  OS2DdeInitializeA\n"));
+    dprintf(("USER32: DdeInitializeA\n"));
 
     return O32_DdeInitialize(arg1, arg2, arg3, arg4);
@@ -177,5 +177,5 @@
 {
 
-    dprintf(("USER32:  OS2DdeInitializeW\n"));
+    dprintf(("USER32: DdeInitializeW\n"));
 
     // NOTE: This will not work as is (needs UNICODE support)
@@ -187,5 +187,5 @@
 {
 
-    dprintf(("USER32:  OS2DdeKeepStringHandle\n"));
+    dprintf(("USER32: DdeKeepStringHandle\n"));
 
     return O32_DdeKeepStringHandle(arg1, arg2);
@@ -196,5 +196,5 @@
 {
 
-    dprintf(("USER32:  OS2DdeNameService\n"));
+    dprintf(("USER32: DdeNameService\n"));
 
     return O32_DdeNameService(arg1, arg2, arg3, arg4);
@@ -205,5 +205,5 @@
 {
 
-    dprintf(("USER32:  OS2DdePostAdvise\n"));
+    dprintf(("USER32: DdePostAdvise\n"));
 
     return O32_DdePostAdvise(arg1, arg2, arg3);
@@ -214,5 +214,5 @@
 {
 
-    dprintf(("USER32:  OS2DdeQueryConvInfo\n"));
+    dprintf(("USER32: DdeQueryConvInfo\n"));
 
     return O32_DdeQueryConvInfo(arg1, arg2, arg3);
@@ -223,5 +223,5 @@
 {
 
-    dprintf(("USER32:  OS2DdeQueryNextServer\n"));
+    dprintf(("USER32: DdeQueryNextServer\n"));
 
     return O32_DdeQueryNextServer(arg1, arg2);
@@ -232,5 +232,10 @@
 {
 
-    dprintf(("USER32:  OS2DdeQueryStringA\n"));
+    dprintf(("USER32: DdeQueryStringA (%08xh, %08xh, %08xh, %08xh, %08xh\n",
+             arg1,
+             arg2,
+             arg3,
+             arg4,
+             arg5));
 
     return O32_DdeQueryString(arg1, arg2, arg3, arg4, arg5);
@@ -240,11 +245,11 @@
 DWORD WIN32API DdeQueryStringW(DWORD arg1, HSZ arg2, LPWSTR arg3, DWORD arg4, int  arg5)
 {
- char *astring = UnicodeToAsciiString(arg3);
- DWORD rc;
-
-    dprintf(("USER32:  OS2DdeQueryStringW\n"));
-    rc = O32_DdeQueryString(arg1, arg2, astring, arg4, arg5);
-    FreeAsciiString(astring);
-    return rc;
+  char *astring = UnicodeToAsciiString(arg3);
+  DWORD rc;
+
+  dprintf(("USER32: DdeQueryStringW\n"));
+  rc = O32_DdeQueryString(arg1, arg2, astring, arg4, arg5);
+  FreeAsciiString(astring);
+  return rc;
 }
 //******************************************************************************
@@ -253,5 +258,5 @@
 {
 
-    dprintf(("USER32:  OS2DdeReconnect\n"));
+    dprintf(("USER32: DdeReconnect\n"));
 
     return O32_DdeReconnect(arg1);
@@ -262,5 +267,5 @@
 {
 
-    dprintf(("USER32:  OS2DdeSetUserHandle\n"));
+    dprintf(("USER32: DdeSetUserHandle\n"));
 
     return O32_DdeSetUserHandle(arg1, arg2, arg3);
@@ -271,5 +276,5 @@
 {
 
-    dprintf(("USER32:  OS2DdeUnaccessData\n"));
+    dprintf(("USER32: DdeUnaccessData\n"));
 
     return O32_DdeUnaccessData(arg1);
@@ -280,5 +285,5 @@
 {
 
-    dprintf(("USER32:  OS2DdeUninitialize\n"));
+    dprintf(("USER32: DdeUninitialize\n"));
 
     return O32_DdeUninitialize(arg1);