Index: trunk/src/user32/USER32.DEF
===================================================================
--- trunk/src/user32/USER32.DEF	(revision 430)
+++ trunk/src/user32/USER32.DEF	(revision 432)
@@ -1,3 +1,3 @@
-; $Id: USER32.DEF,v 1.8 1999-07-04 19:02:38 sandervl Exp $
+; $Id: USER32.DEF,v 1.9 1999-08-05 23:39:48 phaller Exp $
 
 ;Created by BLAST for IBM's compiler
@@ -485,5 +485,5 @@
     SetFocus                   = _SetFocus@4                 @475
     SetForegroundWindow        = _SetForegroundWindow@4      @476
-;    SetInternalWindowPos       = _SetInternalWindowPos@??    @477
+    SetInternalWindowPos       = _SetInternalWindowPos@16    @477
     SetKeyboardState           = _SetKeyboardState@4         @478
     SetLastErrorEx             = _SetLastErrorEx@8           @479
Index: trunk/src/user32/new/unknown.cpp
===================================================================
--- trunk/src/user32/new/unknown.cpp	(revision 430)
+++ trunk/src/user32/new/unknown.cpp	(revision 432)
@@ -1,3 +1,3 @@
-/* $Id: unknown.cpp,v 1.1 1999-07-14 08:35:36 sandervl Exp $ */
+/* $Id: unknown.cpp,v 1.2 1999-08-05 23:39:48 phaller Exp $ */
 
 /*
@@ -12,8 +12,8 @@
 #include <os2win.h>
 
-
 /*****************************************************************************
  * Defines                                                                   *
  *****************************************************************************/
+
 
 /*****************************************************************************
@@ -176,2 +176,18 @@
 }
 
+
+/***********************************************************************
+ *           SetInternalWindowPos   (USER32.483)
+ */
+void WIN32API SetInternalWindowPos(HWND    hwnd,
+                                   UINT    showCmd,
+                                   LPRECT  rect,
+                                   LPPOINT pt )
+{
+  dprintf(("USER32: SetInternalWindowPos(%08xh,%08xh,%08xh,%08xh) not implemented.\n",
+           hwnd,
+           showCmd,
+           rect,
+           pt));
+}
+
Index: trunk/src/user32/new/user32.def
===================================================================
--- trunk/src/user32/new/user32.def	(revision 430)
+++ trunk/src/user32/new/user32.def	(revision 432)
@@ -1,3 +1,3 @@
-; $Id: user32.def,v 1.3 1999-07-20 07:42:35 sandervl Exp $
+; $Id: user32.def,v 1.4 1999-08-05 23:40:16 phaller Exp $
 
 ;Created by BLAST for IBM's compiler
@@ -485,5 +485,5 @@
     SetFocus                   = _SetFocus@4                 @475
     SetForegroundWindow        = _SetForegroundWindow@4      @476
-;    SetInternalWindowPos       = _SetInternalWindowPos@??    @477
+    SetInternalWindowPos       = _SetInternalWindowPos@16    @477
     SetKeyboardState           = _SetKeyboardState@4         @478
     SetLastErrorEx             = _SetLastErrorEx@8           @479
Index: trunk/src/user32/unknown.cpp
===================================================================
--- trunk/src/user32/unknown.cpp	(revision 430)
+++ trunk/src/user32/unknown.cpp	(revision 432)
@@ -1,3 +1,3 @@
-/* $Id: unknown.cpp,v 1.2 1999-06-24 08:25:22 phaller Exp $ */
+/* $Id: unknown.cpp,v 1.3 1999-08-05 23:39:48 phaller Exp $ */
 
 /*
@@ -12,8 +12,8 @@
 #include <os2win.h>
 
-
 /*****************************************************************************
  * Defines                                                                   *
  *****************************************************************************/
+
 
 /*****************************************************************************
@@ -176,2 +176,18 @@
 }
 
+
+/***********************************************************************
+ *           SetInternalWindowPos   (USER32.483)
+ */
+void WIN32API SetInternalWindowPos(HWND    hwnd,
+                                   UINT    showCmd,
+                                   LPRECT  rect,
+                                   LPPOINT pt )
+{
+  dprintf(("USER32: SetInternalWindowPos(%08xh,%08xh,%08xh,%08xh) not implemented.\n",
+           hwnd,
+           showCmd,
+           rect,
+           pt));
+}
+